! dgelsd-bug.f

program bug

  implicit none

  integer m, n, nrhs, lda, ldb, lwork
  parameter(m=4096, n=80, nrhs=1)
  parameter(lda=4096, ldb=4096, lwork=6996)

  integer m1, n1, nrhs1, lda1, ldb1, lwork1, rank, info
  doubleprecision a(lda,n), b(ldb,nrhs), s(n), work(lwork), rcond
  integer         iwork(8560)

  logical bad

  open(1, file='dgelsd.dat')
  read(1,*) m1, n1, nrhs1     ! 4096, 80, 1
  read(1,*) lda1, ldb1        ! 4096, 4096
  read(1,*) lwork1            ! 6996
  read(1,*) a
  read(1,*) b
  read(1,*) s
  read(1,*) rcond
  print*, 'rcond = ', rcond
!      read(1,*) rank
!      read(1,*) work
!      read(1,*) iwork             ! Math.min(m,n) * (3 * 32 + 11)
!      read(1,*) info
  close(1)

  bad =      (m1     .ne. m)     &
        .or. (n1     .ne. n)     &
        .or. (nrhs1  .ne. nrhs)  &
        .or. (lda1   .ne. lda)   &
        .or. (ldb1   .ne. ldb)   &
        .or. (lwork1 .ne. lwork)

  if (bad) then
    write(0,*) 'SOMETHING WENT WRONG...'
    STOP
  endif

  write(0,*) 'minmax(a) = ', minval(a), maxval(a)

  write(0,*) 'Calling DGELSD...'

  call DGELSD(m, n, nrhs, a, lda, b, ldb, s, rcond, rank, &
              work, lwork, iwork, info)

  write(0,*) 'Done with DGELSD.'

endprogram bug

! End of file
